#include "chdecl.h"
void CH_selectstrings(current, sched, cop)
#define ARGUMENTS 6
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto cb4;
    case 4: goto c5;
    case 5: goto cb8;
    case 6: goto c9;
    case 7: goto cb12;
    case 8: goto c13;
    case 9: goto c16;
    case 10: goto cb16;
    case 11: goto c17;
    case 12: goto c18;
    case 13: goto c22;
    case 14: goto c24;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* chs_lit 4 , "stdin" */
  if( !chs_lit(DEF(4),"stdin") ) goto ch_depletion;
/* chs_lit 5 , "string" */
  if( !chs_lit(DEF(5),"string") ) goto ch_depletion;
  current->ip = 3;
cb4:
/* call 3.2.2 4 5 6 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(4),
          arguments[2] = DEF(5),
          arguments[3] = DEF(6),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c5:
/* unwrap 7 6 , 2 */
  if ((ch_returncode = che_unwrap(DEF(7),DEF(6),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
/* chs_lit 8 , "mask" */
  if( !chs_lit(DEF(8),"mask") ) goto ch_depletion;
/* chs_lit 9 , "boolean" */
  if( !chs_lit(DEF(9),"boolean") ) goto ch_depletion;
  current->ip = 5;
cb8:
/* call 3.2.2 8 9 10 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(8),
          arguments[2] = DEF(9),
          arguments[3] = DEF(10),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c9:
/* unwrap 11 10 , 3 */
  if ((ch_returncode = che_unwrap(DEF(11),DEF(10),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
/* chs_lit 12 , "stdout" */
  if( !chs_lit(DEF(12),"stdout") ) goto ch_depletion;
/* chs_lit 13 , "string" */
  if( !chs_lit(DEF(13),"string") ) goto ch_depletion;
  current->ip = 7;
cb12:
/* call 3.2.2 12 13 14 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(12),
          arguments[2] = DEF(13),
          arguments[3] = DEF(14),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c13:
/* unwrap 15 14 , 4 */
  if ((ch_returncode = che_unwrap(DEF(15),DEF(14),QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
c14:
/* noop */
  
c16:
  current->ip = 10;
cb16:
/* receive 16 7 */
  if ((ch_returncode = che_receive(DEF(16),DEF(7),sched)) != Normal)
     goto ch_raise_exception;
  return;
c17:
/* receive 17 11 */
  if ((ch_returncode = che_receive(DEF(17),DEF(11),sched)) != Normal)
     goto ch_raise_exception;
  return;
c18:
/* branch_false 17 , 20 */
  if ( !REF(17).value.boolean ) goto c20;
/* send 15 16 */
  if ((ch_returncode = che_send(DEF(15),DEF(16),sched)) != Normal)
     goto ch_raise_exception;
c20:
/* discard 16 */
  (*(REF(16).tsdr)->finalize)(REF(16).value,F_DISCARD,sched);
  REF(16).tsdr = & dr_bottom;
/* branch , 14 */
   goto c14;
c22:
/* endblock */
  che_endblock(sched);
c24:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
